def merge(left, right):
    left_finger = 0
    right_finger = 0
    merged = []

    while left_finger < len(left) and right_finger < len(right):
        if left[left_finger] <= right[right_finger]:
            merged.append(left[left_finger])
            left_finger += 1
        else:
            merged.append(right[right_finger])
            right_finger += 1

    # deal with remaining elements
    merged = merged + left[left_finger:] + right[right_finger:]

    return merged

def merge_sort(arr):
    print("sorting", arr)
    # base case
    if len(arr) <= 1:
        print("base case:", arr)
        return arr

    # split arr in half, recursively sort each half
    # then merge the sorted halves together
    midpoint = int(len(arr) / 2)

    left_sorted = merge_sort(arr[0:midpoint])
    right_sorted = merge_sort(arr[midpoint:])
    merged = merge(left_sorted, right_sorted)
    print("returning", merged)
    return merged

# nums = [4, 1, 6, 7, 3, 10, 2, 5]
nums = [70, 68, 93, 9, 63, 30]
print(merge_sort(nums))